# Retrieve a single timesheet entry

GET https://api.letsdeel.com/rest/v2/timesheets/{id}

Retrieve a single timesheet entry by Id.
 **Token scopes**: `timesheets:read`

Reference: https://developer.deel.com/api/endpoints/timesheets/get-timesheet-by-id

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /timesheets/{id}:
    get:
      operationId: get-timesheet-by-id
      summary: Retrieve a single timesheet entry
      description: |-
        Retrieve a single timesheet entry by Id.
         **Token scopes**: `timesheets:read`
      tags:
        - subpackage_timesheets
      parameters:
        - name: id
          in: path
          description: ID of an existing timesheet
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful operation.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/timesheets_getTimesheetById_Response_200'
        '400':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataId:
      oneOf:
        - type: string
        - type: integer
          format: int64
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaDataId
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataStatus:
      type: string
      enum:
        - approved
        - declined
        - not_payable
        - paid
        - pending
        - processing
      description: Status of this entry.
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaDataStatus
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataContractType:
      type: string
      enum:
        - ongoing_time_based
        - milestones
        - time_based
        - pay_as_you_go_time_based
        - commission
        - payg_milestones
        - payg_tasks
        - eor
        - unknown
        - employee
        - global_payroll
        - shield_msa
        - hris_direct_employee
        - peo
      description: Type of a contract
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaDataContractType
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataContract:
      type: object
      properties:
        id:
          type: string
        type:
          $ref: >-
            #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataContractType
          description: Type of a contract
        title:
          type: string
      required:
        - id
        - type
        - title
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaDataContract
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataWorksheet:
      type: object
      properties:
        days:
          type: number
          format: double
        hours:
          type: number
          format: double
        weeks:
          type: number
          format: double
        minutes:
          type: number
          format: double
      required:
        - days
        - hours
        - weeks
        - minutes
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaDataWorksheet
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataAttachment:
      type: object
      properties:
        key:
          type: string
          description: >-
            You can call attachments end-point, get key and URL to upload your
            file.
        filename:
          type: string
          description: Original filename you used to upload using attachments end-point.
      required:
        - key
        - filename
      description: This object is used for linking file attachments to your records.
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaDataAttachment
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataReportedById:
      oneOf:
        - type: string
        - type: integer
          format: int64
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaDataReportedById
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataReportedBy:
      type: object
      properties:
        id:
          $ref: >-
            #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataReportedById
        full_name:
          type: string
      required:
        - id
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaDataReportedBy
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataReviewedById:
      oneOf:
        - type: string
        - type: integer
          format: int64
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaDataReviewedById
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataReviewedBy:
      type: object
      properties:
        id:
          $ref: >-
            #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataReviewedById
        remarks:
          type: string
        full_name:
          type: string
        reviewed_at:
          type: string
      required:
        - id
        - remarks
        - reviewed_at
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaDataReviewedBy
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataPaymentCycle:
      type: object
      properties:
        end_date:
          type:
            - string
            - 'null'
          format: date-time
          description: Long date-time format following ISO-8601
        start_date:
          type:
            - string
            - 'null'
          format: date-time
          description: Long date-time format following ISO-8601
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaDataPaymentCycle
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataHourlyReportPreset:
      type: object
      properties:
        id:
          type:
            - string
            - 'null'
          description: unique identifier of the related timesheet preset
        rate:
          type:
            - number
            - 'null'
          format: double
          description: the hourly rate of the related timesheet preset
        title:
          type:
            - string
            - 'null'
          description: the title of the related timesheet preset
        description:
          type:
            - string
            - 'null'
          description: the description of the related timesheet preset
      title: >-
        TimesheetsIdGetResponsesContentApplicationJsonSchemaDataHourlyReportPreset
    TimesheetsIdGetResponsesContentApplicationJsonSchemaDataApproversItems:
      type: object
      properties:
        email:
          type: string
        approved:
          type: boolean
        full_name:
          type: string
      required:
        - approved
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaDataApproversItems
    TimesheetsIdGetResponsesContentApplicationJsonSchemaData:
      type: object
      properties:
        id:
          $ref: >-
            #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataId
        type:
          type: string
          description: Deprecated - it is always "work"
        scale:
          type:
            - string
            - 'null'
        status:
          oneOf:
            - $ref: >-
                #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataStatus
            - type: 'null'
          description: Status of this entry.
        contract:
          $ref: >-
            #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataContract
        quantity:
          type:
            - number
            - 'null'
          format: double
        worksheet:
          oneOf:
            - $ref: >-
                #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataWorksheet
            - type: 'null'
        attachment:
          oneOf:
            - $ref: >-
                #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataAttachment
            - type: 'null'
          description: This object is used for linking file attachments to your records.
        created_at:
          type: string
        description:
          type: string
        reported_by:
          $ref: >-
            #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataReportedBy
        reviewed_by:
          oneOf:
            - $ref: >-
                #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataReviewedBy
            - type: 'null'
        custom_scale:
          type:
            - string
            - 'null'
        total_amount:
          type: string
          description: >-
            is equal to quantity times rate of active work statement + bonus in
            this record
        currency_code:
          type: string
        payment_cycle:
          $ref: >-
            #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataPaymentCycle
        date_submitted:
          type: string
          format: date-time
          description: Long date-time format following ISO-8601
        hourly_report_preset:
          oneOf:
            - $ref: >-
                #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataHourlyReportPreset
            - type: 'null'
        approvers:
          type: array
          items:
            $ref: >-
              #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaDataApproversItems
      required:
        - id
        - type
        - status
        - contract
        - quantity
        - worksheet
        - attachment
        - created_at
        - description
        - reported_by
        - reviewed_by
        - total_amount
        - currency_code
        - date_submitted
        - approvers
      title: TimesheetsIdGetResponsesContentApplicationJsonSchemaData
    timesheets_getTimesheetById_Response_200:
      type: object
      properties:
        data:
          $ref: >-
            #/components/schemas/TimesheetsIdGetResponsesContentApplicationJsonSchemaData
      required:
        - data
      title: timesheets_getTimesheetById_Response_200
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/timesheets/id"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/timesheets/id';
const options = {
  method: 'GET',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/timesheets/id"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/timesheets/id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.letsdeel.com/rest/v2/timesheets/id")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.letsdeel.com/rest/v2/timesheets/id', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/timesheets/id");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/timesheets/id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```